LeetCode刷题笔记-1. 两数之和
给定一个整数数组 nums和一个整数目标值 target,请你在该数组中找出 和为目标值 的那两个 整数,并返回它们的数组下标。
你可以假设每种输入只会对应一个答案。但是,数组中同一个元素不能使用两遍。
你可以按任意顺序返回答案。
示例 1:
输入:nums = [2,7,11,15], target = 9
输出:[0,1]
解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1] 。
示例 2:
输入:nums = [3,2,4], target = 6
输出:[1,2]
示例 3:
输入:nums = [3,3], target = 6
输出:[0,1]
1.暴力解法
public static int[] twoSum(int[] nums, int target) {
for(int i = 0; i < nums.length; i++){
for(int j = i + 1; j < nums.length; j++){
if(nums[i] + nums[j] == target){
return new int[] {i,j};
}
}
}
throw new IllegalArgumentException("No two sum solution");
}
时间复杂度:
$O(n^2)$
2.HashTable
public static int[] twoSum(int[] nums, int target) {
Map<Integer,Integer> table = new HashMap<>();
for(int i = 0; i < nums.length; i++){
int complement = target - nums[i];
if(table.containsKey(complement)){
return new int[]{table.get(complement),i};
}else{
table.put(nums[i],i);
}
}
throw new IllegalArgumentException("No two sum Solution");
}
时间复杂度:
$O(n)$
利用HashMap的查询优势,用空间换时间,减少时间复杂度。
LeetCode刷题笔记-1. 两数之和
https://www.zhaojun.inkhttps://www.zhaojun.ink/archives/leetcode-tow-sum